-- This folder (scripts/modules) contains lua modules that provide generic functionality which 
-- can be used anywhere in the plugin.

local _M = {}

-- This function can be used to encode a URL with a specific parameter:

function _M.URL_Encode (url)
    return url:gsub("%W", function (c)
                            return string.format("%%%02X", string.byte(c))
                         end)
end


-- This function can be used to generate a random hex string:

function _M.RandomHexString (len)
    local rs = ""

    for _ = 1, len do
        rs = rs .. string.format("%02x", math.random(32, 126))
    end

    return rs
end


-- By returning a table which contains the functions we want to expose we are simulating the
-- implementation of a class. Any local variable we declare in our plugin scripts is private
-- to this module only. This lets us simplistically mimic OOP programming.

return _M

-- NOTE - We don't use this module's functionality in this demo plugin, but we included it as an example.
